tftpd: options -c (allow _new_ files to be uploaded) and -u USER
[oweals/busybox.git] / scripts / trylink
index c621b7c018f81131d7905ef4857dd1443620d024..ebfe6cee3471bdca8a7138d4add6b41035cb37e9 100755 (executable)
@@ -2,6 +2,40 @@
 
 debug=false
 
+# Linker flags used:
+#
+# Informational:
+# --warn-common
+# -Map $EXE.map
+# --verbose
+#
+# Optimizations:
+# --sort-common                 reduces padding
+# --sort-section alignment      reduces padding
+# --gc-sections                 throws out unused sections,
+#                               does not work for shared libs
+# -On                           Not used, maybe useful?
+#
+# List of files to link:
+# $l_list                       == --start-group -llib1 -llib2 --end-group
+# --start-group $O_FILES $A_FILES --end-group
+#
+# Shared library link:
+# -shared                       self-explanatory
+# -fPIC                         position-independent code
+# --enable-new-dtags            ?
+# -z,combreloc                  ?
+# -soname="libbusybox.so.$BB_VER"
+# --undefined=lbb_main          Seed name to start pulling from
+#                               (otherwise we'll need --whole-archive)
+# -static                       Not used, but may be useful! manpage:
+#                               "... This option can be used with -shared.
+#                               Doing so means that a shared library
+#                               is being created but that all of the library's
+#                               external references must be resolved by pulling
+#                               in entries from static libraries."
+
+
 try() {
     printf "%s\n" "Output of:" >$EXE.out
     printf "%s\n" "$*" >>$EXE.out
@@ -9,16 +43,62 @@ try() {
     $debug && echo "Trying: $*"
     "$@" >>$EXE.out 2>&1
     exitcode=$?
-    cat $EXE.out
     return $exitcode
 }
 
+check_cc() {
+    local tempname="/tmp/temp.$$.$RANDOM"
+    # Can use "-o /dev/null", but older gcc tend to *unlink it* on failure! :(
+    # "-xc": C language. "/dev/null" is an empty source file.
+    if $CC $1 -shared -xc /dev/null -o "$tempname".o >/dev/null 2>&1; then
+       echo "$1";
+    else
+       echo "$2";
+    fi
+    rm "$tempname".o 2>/dev/null
+}
+
+check_libc_is_glibc() {
+    local tempname="/tmp/temp.$$.$RANDOM"
+    echo "\
+       #include <stdlib.h>
+       /* Apparently uclibc defines __GLIBC__ (compat trick?). Oh well. */
+       #if defined(__GLIBC__) && !defined(__UCLIBC__)
+       syntax error here
+       #endif
+       " >"$tempname"
+    if $CC "$tempname".c -c -o "$tempname".o >/dev/null 2>&1; then
+       echo "$2";
+    else
+       echo "$1";
+    fi
+    rm "$tempname".c "$tempname".o 2>/dev/null
+}
+
 EXE="$1"
 CC="$2"
-LDFLAGS="$3"
-O_FILES="$4"
-A_FILES="$5"
-LDLIBS="$6"
+CFLAGS="$3"
+LDFLAGS="$4"
+O_FILES="$5"
+A_FILES="$6"
+LDLIBS="$7"
+
+# The -Wl,--sort-section option is not supported by older versions of ld
+SORT_SECTION=`check_cc "-Wl,--sort-section -Wl,alignment" ""`
+
+# Static linking against glibc produces buggy executables
+# (glibc does not cope well with ld --gc-sections).
+# See sources.redhat.com/bugzilla/show_bug.cgi?id=3400
+# Note that glibc is unsuitable for static linking anyway.
+# We are removing -Wl,--gc-sections from link command line.
+GC_SECTION=`(
+. ./.config
+if test x"$CONFIG_STATIC" = x"y"; then
+    check_libc_is_glibc "" "-Wl,--gc-sections"
+else
+    echo "-Wl,--gc-sections"
+fi
+)`
 
 # Sanitize lib list (dups, extra spaces etc)
 LDLIBS=`echo "$LDLIBS" | xargs -n1 | sort | uniq | xargs`
@@ -28,12 +108,13 @@ echo "Trying libraries: $LDLIBS"
 # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
 l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
 test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
-try $CC $LDFLAGS \
-       -o $EXE -Wl,-Map -Wl,$EXE.map \
-       -Wl,--warn-common -Wl,--sort-common -Wl,--gc-sections \
+try $CC $CFLAGS $LDFLAGS \
+       -o $EXE \
+       -Wl,--sort-common \
+       $SORT_SECTION \
+       $GC_SECTION \
        -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
        $l_list \
-       >/dev/null \
 || {
     echo "Failed: $* $l_list"
     cat $EXE.out
@@ -51,18 +132,19 @@ while test "$LDLIBS"; do
        l_list=`echo "$without_one" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
        test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
        $debug && echo "Trying -l options: '$l_list'"
-       try $CC $LDFLAGS \
-               -o $EXE -Wl,-Map -Wl,$EXE.map \
-               -Wl,--warn-common -Wl,--sort-common -Wl,--gc-sections \
+       try $CC $CFLAGS $LDFLAGS \
+               -o $EXE \
+               -Wl,--sort-common \
+               $SORT_SECTION \
+               $GC_SECTION \
                -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
-               $l_list \
-               >/dev/null
+               $l_list
        if test $? = 0; then
-           echo "Library $one is not needed"
+           echo " Library $one is not needed"
            LDLIBS="$without_one"
            all_needed=false
        else
-           echo "Library $one is needed"
+           echo " Library $one is needed"
        fi
     done
     # All libs were needed, can't remove any
@@ -74,17 +156,25 @@ while test "$LDLIBS"; do
 done
 
 # Make the binary with final, minimal list of libs
-echo "Final link with: $LDLIBS"
+echo "Final link with: ${LDLIBS:-<none>}"
 l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
-test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group -Wl,--verbose"
+test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
 # --verbose gives us gobs of info to stdout (e.g. linker script used)
 if ! test -f busybox_ldscript; then
-    try $CC $LDFLAGS \
-           -o $EXE -Wl,-Map -Wl,$EXE.map \
-           -Wl,--warn-common -Wl,--sort-common -Wl,--gc-sections \
+    try $CC $CFLAGS $LDFLAGS \
+           -o $EXE \
+           -Wl,--sort-common \
+           $SORT_SECTION \
+           $GC_SECTION \
            -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
-           $l_list -Wl,--verbose \
-           >/dev/null
+           $l_list \
+           -Wl,--warn-common \
+           -Wl,-Map -Wl,$EXE.map \
+           -Wl,--verbose \
+    || {
+       cat $EXE.out
+       exit 1
+    }
 else
     echo "Custom linker script 'busybox_ldscript' found, using it"
     # Add SORT_BY_ALIGNMENT to linker script (found in $EXE.out):
@@ -92,44 +182,121 @@ else
     #  *(.data SORT_BY_ALIGNMENT(.data.*) .gnu.linkonce.d.*)
     #  *(.bss SORT_BY_ALIGNMENT(.bss.*) .gnu.linkonce.b.*)
     # This will eliminate most of the padding (~3kb).
-    try $CC $LDFLAGS \
-           -o $EXE -Wl,-Map -Wl,$EXE.map \
-           -Wl,--warn-common -Wl,--sort-common -Wl,--gc-sections \
-           -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
-           $l_list -Wl,--verbose \
+    # Hmm, "ld --sort-section alignment" should do it too.
+    try $CC $CFLAGS $LDFLAGS \
+           -o $EXE \
+           -Wl,--sort-common \
+           $SORT_SECTION \
+           $GC_SECTION \
            -Wl,-T -Wl,busybox_ldscript \
-           >/dev/null
+           -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
+           $l_list \
+           -Wl,--warn-common \
+           -Wl,-Map -Wl,$EXE.map \
+           -Wl,--verbose \
+    || {
+       cat $EXE.out
+       exit 1
+    }
 fi
 
-mkdir 0lib 2>/dev/null
-test -d 0lib || exit 1
-ln -s libbusybox.so.1.8.0 0lib/libbusybox.so 2>/dev/null
-
-EXE="0lib/libbusybox.so.1.8.0"
-try $CC $LDFLAGS \
-       -o $EXE -Wl,-Map -Wl,$EXE.map \
-       -shared -fPIC -Wl,--enable-new-dtags \
-       -Wl,--start-group -Wl,--whole-archive $A_FILES -Wl,--no-whole-archive -Wl,--end-group \
-       $l_list -Wl,--verbose \
-       -Wl,-soname="libbusybox.so.1.8.0" \
-       -Wl,-z,combreloc \
-       >/dev/null \
-|| {
-    echo "Linking $EXE failed"
-    exit 1
-}
-strip -s --remove-section=.note --remove-section=.comment $EXE
-
-EXE="0lib/busybox"
-try $CC $LDFLAGS \
-       -o $EXE -Wl,-Map -Wl,$EXE.map \
-       -Wl,--warn-common -Wl,--sort-common -Wl,--gc-sections \
-       -Wl,--start-group $O_FILES -Wl,--end-group \
-       $l_list -Wl,--verbose \
-       -L"0lib" -lbusybox \
-       >/dev/null \
-|| {
-    echo "Linking $EXE failed"
-    exit 1
+. ./.config
+
+sharedlib_dir="0_lib"
+
+if test "$CONFIG_BUILD_LIBBUSYBOX" = y; then
+    mkdir "$sharedlib_dir" 2>/dev/null
+    test -d "$sharedlib_dir" || {
+       echo "Cannot make directory $sharedlib_dir"
+       exit 1
+    }
+    ln -s "libbusybox.so.$BB_VER" "$sharedlib_dir"/libbusybox.so 2>/dev/null
+
+    EXE="$sharedlib_dir/libbusybox.so.${BB_VER}_unstripped"
+    try $CC $CFLAGS $LDFLAGS \
+           -o $EXE \
+           -shared -fPIC \
+           -Wl,--enable-new-dtags \
+           -Wl,-z,combreloc \
+           -Wl,-soname="libbusybox.so.$BB_VER" \
+           -Wl,--undefined=lbb_main \
+           -Wl,--sort-common \
+           $SORT_SECTION \
+           -Wl,--start-group $A_FILES -Wl,--end-group \
+           $l_list \
+           -Wl,--warn-common \
+           -Wl,-Map -Wl,$EXE.map \
+           -Wl,--verbose \
+    || {
+       echo "Linking $EXE failed"
+       cat $EXE.out
+       exit 1
+    }
+    $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/libbusybox.so.$BB_VER"
+    chmod a+x "$sharedlib_dir/libbusybox.so.$BB_VER"
+    echo "libbusybox: $sharedlib_dir/libbusybox.so.$BB_VER"
+fi
+
+if test "$CONFIG_FEATURE_SHARED_BUSYBOX" = y; then
+    EXE="$sharedlib_dir/busybox_unstripped"
+    try $CC $CFLAGS $LDFLAGS \
+           -o $EXE \
+           -Wl,--sort-common \
+           $SORT_SECTION \
+           $GC_SECTION \
+           -Wl,--start-group $O_FILES -Wl,--end-group \
+           -L"$sharedlib_dir" -lbusybox \
+           -Wl,--warn-common \
+           -Wl,-Map -Wl,$EXE.map \
+           -Wl,--verbose \
+    || {
+       echo "Linking $EXE failed"
+       cat $EXE.out
+       exit 1
+    }
+    $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/busybox"
+    echo "busybox linked against libbusybox: $sharedlib_dir/busybox"
+fi
+
+if test "$CONFIG_FEATURE_INDIVIDUAL" = y; then
+    echo "Linking individual applets against libbusybox (see $sharedlib_dir/*)"
+    gcc -DNAME_MAIN_CNAME -E -include include/autoconf.h include/applets.h \
+    | grep -v "^#" \
+    | grep -v "^$" \
+    > applet_lst.tmp
+    while read name main junk; do
+
+       echo "\
+void lbb_prepare(const char *applet, char **argv);
+int $main(int argc, char **argv);
+
+int main(int argc, char **argv)
+{
+       lbb_prepare(\"$name\", argv);
+       return $main(argc, argv);
 }
-strip -s --remove-section=.note --remove-section=.comment $EXE
+" >"$sharedlib_dir/applet.c"
+
+       EXE="$sharedlib_dir/$name"
+       try $CC $CFLAGS $LDFLAGS "$sharedlib_dir/applet.c" \
+               -o $EXE \
+               -Wl,--sort-common \
+               $SORT_SECTION \
+               $GC_SECTION \
+               -L"$sharedlib_dir" -lbusybox \
+               -Wl,--warn-common \
+       || {
+           echo "Linking $EXE failed"
+           cat $EXE.out
+           exit 1
+       }
+       rm -- "$sharedlib_dir/applet.c" $EXE.out
+       $STRIP -s --remove-section=.note --remove-section=.comment $EXE
+
+    done <applet_lst.tmp
+fi
+
+# libbusybox.so is needed only for -lbusybox at link time,
+# it is not needed at runtime. Deleting to reduce confusion.
+rm "$sharedlib_dir"/libbusybox.so 2>/dev/null
+exit 0 # or else we may confuse make